#include "mxframe.h"


QVector<QString> explode(const QString& s, const char& c)
{
    QString buff{""};
    QVector<QString> v;

    for(auto n:s)
    {
        if(n != c) buff+=n; else
        if(n == c && buff != "") { v.push_back(buff); buff = ""; }
    }
    if(buff != "") v.push_back(buff);

    return v;
}

QColor MxFrame::qp4strToColor(const QString& str)
{
    uint32_t col;
    if (str.startsWith("0x"))
    {
        bool ok = false;
        col = str.mid(2).toUInt(&ok, 16);
    }
    else {
        bool ok = false;
        col = str.toUInt(&ok);
    }
    uint8_t blue = (col >> 0) & 0xFF;
    uint8_t green = (col >> 8) & 0xFF;
    uint8_t red = (col >> 16) & 0xFF;
    uint8_t alpha = (col >> 24) & 0xFF;
    return QColor(red, green, blue, alpha);
}

MxFrame::MxFrame()
{

}

// frame({pix1, pix2, ...},1000)
MxFrame::MxFrame(const QString &import)
{
    int posBegin = import.indexOf('{');
    int posEnd = import.indexOf('}');
    QString line = import.mid(posBegin+1, posEnd - posBegin-1);
    line = line.remove(' ');
    line = line.remove('\r');
    line = line.remove('\n');
    line = line.remove('\t');
    QStringList data = line.split(',');
    for(int i = 0; i < data.size() && i < 26*32; i++)
    {
        int y = i / 32;
        int x = i % 32;
        pixels[y][x] = qp4strToColor(data.at(i));
    }
    int lastcomma = import.lastIndexOf(',');
    int lastbracket = import.lastIndexOf(')');
    QString alma = import.mid(lastcomma+1,lastbracket-lastcomma-1);
    this->length = import.mid(lastcomma+1,lastbracket-lastcomma-1).toUInt();
}


