#ifndef ANIMATION_H
#define ANIMATION_H

//#include <QFile>
//#include <QString>
#include <vector>
#include <string>
#include "mxframe.h"
#include "spiframe.h"
#include <tuple>

class Animation
{
private:
    std::vector<MxFrame> frames;
    uint32_t frameId = 0;
public:
    Animation();
    void openFile(const std::string& filepath);
    MxFrame nextFrame();
    MxFrame getCurrentFrame() const;
    uint32_t getCurrentTime() const;
    bool eof() const;
    uint32_t getTimeLength() const;
    uint32_t getFrameNum() const;
    uint32_t getFrameId() const;
    uint32_t setFrameId(uint32_t id);
    uint32_t seek(uint32_t time_ms);
};

#endif // ANIMATION_H
