#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include "filebrowser.h"
#include "animhandler.h"
#include "mxemu.h"
#include "mxframe.h"
#include <QListWidget>
#include <QDialog>
#include <QProgressBar>
#include <QPushButton>

QT_BEGIN_NAMESPACE
namespace Ui { class MainWindow; }
QT_END_NAMESPACE

class MainWindow : public QDialog
{
    Q_OBJECT

public:
    MainWindow(QWidget *parent = nullptr);
    ~MainWindow();

public slots:
    void fileopened(const std::string filepath);
    void progressupdate(uint32_t t);

private:
    Ui::MainWindow *ui;
    AnimHandler *animhandler;
    FileBrowser *fb;
    QProgressBar *progressbar;
    MxEmu *mxemu;
    QPushButton *btRun;
    QPushButton *btPause;
    QPushButton *btStop;

};
#endif // MAINWINDOW_H
