#include "mxframe.h"
#include <cwctype> 
#include <algorithm>

using namespace std;

vector<string> explode(const string& s, const char& c)
{
    string buff("");
    vector<string> v;

    for(auto n:s)
    {
        if(n != c) buff+=n; else
        if(n == c && buff != "") { v.push_back(buff); buff = ""; }
    }
    if(buff != "") v.push_back(buff);

    return v;
}

Color MxFrame::qp4strToColor(const string& str)
{
    uint64_t col;
    if (str.find("0x") == 0)
    {
        col = stoul(str.substr(2).c_str(), nullptr, 16);
    }
    else {
        col = stoul(str.c_str(), nullptr, 0);
    }
    uint8_t blue = (col >> 0) & 0xFF;
    uint8_t green = (col >> 8) & 0xFF;
    uint8_t red = (col >> 16) & 0xFF;
    uint8_t alpha = (col >> 24) & 0xFF;
    return Color(red, green, blue, 255);
}

MxFrame::MxFrame(Color initcolor)
{
    length = 0;
    for (int y = 0; y < 26; y++) {
        for (int x = 0; x < 32; x++) {
            pixels[y][x] = initcolor;
        }
    }
}

vector<string> splitstr(const string& str, const string& delimiter)
{
    vector<string> strs;
    size_t pos = 0;
    size_t lastpos = 0;
    while ((pos = str.find(delimiter, lastpos)) != std::string::npos) {
        strs.push_back(str.substr(lastpos, pos - lastpos));
        lastpos = pos+1;
    }
    return strs;
}

// frame({pix1, pix2, ...},1000)
MxFrame::MxFrame(const string &import)
{
    size_t posBegin = import.find('{');
    size_t posEnd = import.find('}');
    string line = import.substr(posBegin+1, posEnd - posBegin-1);
    line.erase(remove_if(line.begin(), line.end(), iswspace), line.end());
    vector<string> data = splitstr(line, ",");
    for(size_t i = 0; i < data.size() && i < 26*32; i++)
    {
        size_t y = i / 32;
        size_t x = i % 32;
        pixels[y][x] = qp4strToColor(data[i]);
    }
    size_t lastcomma = import.rfind(',');
    size_t lastbracket = import.rfind(')');
    this->length = strtoul(import.substr(lastcomma+1,lastbracket-lastcomma-1).c_str(),nullptr,10);
}


