#include "spisender.h"
#include "unistd.h"

SpiSender::SpiSender(int readyPin): readyPin(readyPin)
{
//    gpioInitialise();
//    gpioSetMode(readyPin, PI_INPUT);
//    uint32_t flags = (1 << 20);
//    spiHandle = spiOpen(0, 4000000, flags);
}

int SpiSender::getReadyPin() const
{
    return readyPin;
}

bool SpiSender::sendFrame(const SpiFrame &frame, bool waitReady) const
{
    uint8_t* data = static_cast<uint8_t*>(malloc(64*24*2 + 4));
    data[0] = 0x55;
    data[1] = 0x55;
    data[2] = static_cast<uint8_t>(frame.length >> 8);
    data[3] = static_cast<uint8_t>(frame.length);
    for (size_t i = 0; i < 64*24; i++) {
        size_t j = 2 * i + 4;
        data[j] = frame.data[i] >> 8;
        data[j + 1] = static_cast<uint8_t>(frame.data[i]);
    }
    if (waitReady)
    {
        while(!canSend()) usleep(1000);
        //spiWrite(spiHandle, (char*)data, 64*24*2 + 4);
    }
    else if (canSend()) {
//        spiWrite(spiHandle, (char*)data, 64*24*2 + 4);
        return true;
    }
    return false;
}

bool SpiSender::canSend() const
{
    //return gpioRead(26);
    return true;
}

