#include "animation.h"
#include <fstream>
#include <iostream>
#include <sstream> //std::stringstream
//#include <QTextStream>

using namespace std;

Animation::Animation()
{

}

void Animation::openFile(const std::string& filepath)
{
    std::ifstream file;
    file.open(filepath); //open the input file
    if (!file.fail())
    {
        frames.clear();
        frameId = 0;

        std::stringstream strStream;
        strStream << file.rdbuf(); //read the file
        std::string filestr = strStream.str(); //str holds the content of the file
        file.close();

        int start = 0;
        while (1) {
            int begin = filestr.find("frame(", start);
            int end = filestr.find(")", begin) + 1;
            if (begin == -1 || end == -1)
                break;
            start = end;
            frames.push_back(MxFrame(filestr.substr(begin, end - begin)));
        }
    }
}

bool Animation::eof()
{
    return frameId >= frames.size();
}

MxFrame Animation::nextFrame()
{
    if (!eof()) {
        return frames[frameId++];
    }
    else {
        return MxFrame();
    }
}
