#ifndef SPISENDER_H
#define SPISENDER_H

#include "spiframe.h"
#include <pthread.h>
#include <atomic>

class SpiSender
{
private:
    const int readyPin = 6; // WiringPi PIN. (22 on header)
    const int resetPin = 5; // WiringPi PIN. (18 on header)
    const int SPI_SPEED = 18000000;
    const int SPI_CHANNEL = 0;
    int fd = 0;
    bool firstFrame = true;
    bool sendFrame(const SpiFrame& frame) const;
    bool canSend() const;
    MxFrame frame;
    pthread_t sender_thread;
    static pthread_mutex_t mutex_frame;
    std::atomic<bool> exit_flag;

    static void* sender_caller(void* arg);
    void sender_loop();

public:
    SpiSender();
    ~SpiSender();
    void exit();
    void updateFrame(const MxFrame& newFrame, int startY = 0, int endY = 25);
};

#endif // SPISENDER_H
